﻿-------------------------------------------------------------------------------
-- default layout values

nUI_XPBar_Layout =
{
	width  = 515,
	height = 18,
	
	Options =
	{
		cur_value = "none",	
		max_value = "none",	
		grow      = "left",
	},
	
	Colors =
	{
		Normal = { r = 0.6, g = 0, b = 0.6, },
		Rested = { r = 0.25, g = 0.75, b = 0.25, },
		bg     = { r = 0, g = 0, b = 0, a = 0, },
		overlay  = "Interface\\AddOns\\nUI\\Bars\\Art\\nUI_BarOverlay2.blp",
	},
	
	Origin =
	{
		anchor = "TOPRIGHT",
		xOfs   = -168,
		yOfs   = -232,
	},
	
	Label =
	{
		anchor = "CENTER",
		size   = 22,
		xOfs   = 0,
		yOfs   = 25,
		
		Colors =
		{
			Rested =
			{
				r = 0.75,
				g = 1,
				b = 0.75,
			},
			Normal =
			{
				r = 1,
				g = 1,
				b = 1,
			},
		},
	},
};

nUI.Class.XPBarLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local prototype       = nUI.Class.XPBarLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function prototype:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.Normal then user_defined.Colors.Normal = {}; end
	if not user_defined.Colors.Rested then user_defined.Colors.Rested = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {};	 end
	if not user_defined.Origin then user_defined.Origin = {}; end
	if not user_defined.Label then user_defined.Label = {}; end
	if not user_defined.Label.Colors then user_defined.Label.Colors = {}; end
	if not user_defined.Label.Colors.Rested then user_defined.Label.Colors.Rested = {}; end
	if not user_defined.Label.Colors.Normal then user_defined.Label.Colors.Normal = {}; end
	
	prototype.super.prototype.init( self, user_defined );
	
	self.width  = tonumber( user_defined.width or nUI_XPBar_Layout.width );
	self.height = tonumber( user_defined.height or nUI_XPBar_Layout.height );
	
	self.Options.cur_value = strlower( user_defined.Options.cur_value or nUI_XPBar_Layout.Options.cur_value );
	self.Options.max_value = strlower( user_defined.Options.max_value or nUI_XPBar_Layout.Options.max_value );
	self.Options.grow      = strlower( user_defined.Options.grow or nUI_XPBar_Layout.Options.grow );
	
	self.Colors.Normal =
	{
		r = tonumber( user_defined.Colors.Normal.r or nUI_XPBar_Layout.Colors.Normal.r ),
		g = tonumber( user_defined.Colors.Normal.g or nUI_XPBar_Layout.Colors.Normal.g ),
		b = tonumber( user_defined.Colors.Normal.b or nUI_XPBar_Layout.Colors.Normal.b ),
	};
	
	self.Colors.Rested =
	{
		r = tonumber( user_defined.Colors.Rested.r or nUI_XPBar_Layout.Colors.Rested.r ),
		g = tonumber( user_defined.Colors.Rested.g or nUI_XPBar_Layout.Colors.Rested.g ),
		b = tonumber( user_defined.Colors.Rested.b or nUI_XPBar_Layout.Colors.Rested.b ),
	};
	
	self.Colors.bg =
	{
		r = tonumber( user_defined.Colors.bg.r or nUI_XPBar_Layout.Colors.bg.r ),
		g = tonumber( user_defined.Colors.bg.g or nUI_XPBar_Layout.Colors.bg.g ),
		b = tonumber( user_defined.Colors.bg.b or nUI_XPBar_Layout.Colors.bg.b ),
		a = tonumber( user_defined.Colors.bg.a or nUI_XPBar_Layout.Colors.bg.a ),
	};
	
	self.Origin =
	{
		anchor = strupper( user_defined.Origin.anchor or nUI_XPBar_Layout.Origin.anchor ),
		xOfs   = tonumber( user_defined.Origin.xOfs or nUI_XPBar_Layout.Origin.xOfs ),
		yOfs   = tonumber( user_defined.Origin.yOfs or nUI_XPBar_Layout.Origin.yOfs ),
	};

	self.Colors.overlay   = user_defined.Colors.overlay or nUI_XPBar_Layout.Colors.overlay;

	self.Label =
	{
		anchor = strupper( user_defined.Label.anchor or nUI_XPBar_Layout.Label.anchor ),
		size   = tonumber( user_defined.Label.size or nUI_XPBar_Layout.Label.size ),
		xOfs   = tonumber( user_defined.Label.xOfs or nUI_XPBar_Layout.Label.xOfs ),
		yOfs   = tonumber( user_defined.Label.yOfs or nUI_XPBar_Layout.Label.yOfs ),
		
		Colors =
		{
			Rested =
			{
				r = tonumber( user_defined.Label.Colors.Rested.r or nUI_XPBar_Layout.Label.Colors.Rested.r ),
				g = tonumber( user_defined.Label.Colors.Rested.g or nUI_XPBar_Layout.Label.Colors.Rested.g ),
				b = tonumber( user_defined.Label.Colors.Rested.b or nUI_XPBar_Layout.Label.Colors.Rested.b ),
			},
			Normal =
			{
				r = tonumber( user_defined.Label.Colors.Normal.r or nUI_XPBar_Layout.Label.Colors.Normal.r ),
				g = tonumber( user_defined.Label.Colors.Normal.g or nUI_XPBar_Layout.Label.Colors.Normal.g ),
				b = tonumber( user_defined.Label.Colors.Normal.b or nUI_XPBar_Layout.Label.Colors.Normal.b ),
			},
		},
	};
	
end
