﻿-------------------------------------------------------------------------------
-- default layout values

nUI_HUDLayout =
{
	scale        = 1.5,
	spacing      = 275,
	show_borders = "yes",
	show_npc     = "no",
	
	Origin =
	{
		anchor = "CENTER",
		xOfs   = 0,
		yOfs   = 700,
	},
	
	Alpha =
	{
		rest    = 0,
		regen   = 0.35,
		target  = 0.5,
		combat  = 0.8,
	},

	Bars =
	{
		Cooldown =
		{
			size   = 35,
			gap    = 4,
			anchor = "CENTER",
			xOfs   = 0,
			yOfs   = -350,
			shown  = "yes",
		},		
		
		GCD =
		{
			size    = 24,
			latency = "no",
			anchor  = "BOTTOM",
			xOfs    = 0,
			yOfs    = -245,
			shown   = "yes",
			Color   =
			{
				r = 1,
				g = 1,
				b = 1,
				a = 0.3,
			},
		},		
		
		Player =
		{
			Options = 
			{
				show_name = "min",			-- where to show the name on the bar: min|max|center|none
				cur_value = "none",			-- where to show the current value: min|max|center|outside|none
				max_value = "none",			-- where to show the maximum value: min|max|center|outside|none
				min_value = "none",			-- where to show the minimum value: min|max|center|outside|none
				percent   = "max",			-- where to show the percent of max value: min|max|center|outside|none
				grow      = "right",		-- which direction to grow the bar in: left|right
			};
			Casting =
			{
				visible = "yes",
				pet     = "yes",
				anchor  = "TOP",
				xOfs    = 0,
				yOfs    = -215,
				width   = 300,
				height  = 30,				
			},
			Latency =
			{
				visible = "yes",
				height  = 4,
			},
			Colors =
			{
				Casting = 
				{
					min = {},
					mid = {},
					max = {},
					bg  = { r=0, g=0, b=0, a=0.35 },
				},
				Channeling =
				{
					min = {},
					mid = {},
					max = {},
					bg  = { r=0, g=0, b=0, a=0.35 },
				},
				Latency =
				{
					min = {},
					mid = {},
					max = {},
					bg  = { r=0, g=0, b=0, a=0.35 },
				},
			},
		},
		
		Target =
		{
			Options =
			{
				show_name = "min",			-- where to show the name on the bar: min|max|center|none
				cur_value = "none",			-- where to show the current value: min|max|center|outside|none
				max_value = "none",			-- where to show the maximum value: min|max|center|outside|none
				min_value = "none",			-- where to show the minimum value: min|max|center|outside|none
				percent   = "max",			-- where to show the percent of max value: min|max|center|outside|none
				grow      = "right",		-- which direction to grow the bar in: left|right
			},
			Casting =
			{
				visible = "yes",
				anchor  = "BOTTOM",
				xOfs    = 0,
				yOfs    = 275,
				width   = 375,
				height  = 30,
			},
			Colors =
			{
				Casting = 
				{
					min = {},
					mid = {},
					max = {},
					bg  = { r=0, g=0, b=0, a=0.5 },
				},
				Channeling =
				{
					min = {},
					mid = {},
					max = {},
					bg  = { r=0, g=0, b=0, a=0.5 },
				},
			},
		},
	},
	
	Labels =
	{
		Range =
		{
			size   = 20,
			align  = "CENTER",
			anchor = "TOP",
			xOfs   = 0,
			yOfs   = -410,
			shown  = "yes",
		},		
		
		Player =
		{
			MaxHealth =
			{
				size   = 14,
				align  = "RIGHT",
				anchor = "BOTTOMRIGHT",
				xOfs   = -30,
				yOfs   = 155,
				shown  = "yes",
			},
			CurHealth =
			{
				size   = 14,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -38,
				yOfs   = -127,
				shown  = "yes",
			},
			PctHealth =
			{
				size   = 16,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 50,
				yOfs   = -127,
				shown  = "yes",
			},
			MaxPower =
			{
				size   = 13,
				align  = "RIGHT",
				anchor = "BOTTOMRIGHT",
				xOfs   = -40,
				yOfs   = 138,
				shown  = "yes",
			},
			CurPower =
			{
				size   = 13,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -25,
				yOfs   = -145,
				shown  = "yes",
			},
			PctPower =
			{
				size   = 13,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 58,
				yOfs   = -145,
				shown  = "yes",
			},
		},
		Pet =
		{
			MaxHealth =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -60,
				yOfs   = -5,
				shown  = "yes",
			},
			CurHealth =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = 15,
				yOfs   = -172,
				shown  = "yes",
			},
			PctHealth =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 20,
				yOfs   = -172,
				shown  = "yes",
			},
			MaxPower =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -55,
				yOfs   = -18,
				shown  = "yes",
			},
			CurPower =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = 15,
				yOfs   = -188,
				shown  = "yes",
			},
			PctPower =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 20,
				yOfs   = -188,
				shown  = "yes",
			},
		},
		Target =
		{
			MaxHealth =
			{
				size   = 14,
				align  = "LEFT",
				anchor = "BOTTOMLEFT",
				xOfs   = 30,
				yOfs   = 155,
				shown  = "yes",
			},
			CurHealth =
			{
				size   = 14,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 38,
				yOfs   = -127,
				shown  = "yes",
			},
			PctHealth =
			{
				size   = 16,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -50,
				yOfs   = -127,
				shown  = "yes",
			},
			MaxPower =
			{
				size   = 13,
				align  = "LEFT",
				anchor = "BOTTOMLEFT",
				xOfs   = 40,
				yOfs   = 138,
				shown  = "yes",
			},
			CurPower =
			{
				size   = 13,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 25,
				yOfs   = -145,
				shown  = "yes",
			},
			PctPower =
			{
				size   = 13,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -58,
				yOfs   = -145,
				shown  = "yes",
			},
		},
		ToT =
		{
			MaxHealth =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 60,
				yOfs   = -5,
				shown  = "yes",
			},
			CurHealth =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = -15,
				yOfs   = -172,
				shown  = "yes",
			},
			PctHealth =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -20,
				yOfs   = -172,
				shown  = "yes",
			},
			MaxPower =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = 55,
				yOfs   = -18,
				shown  = "yes",
			},
			CurPower =
			{
				size   = 11,
				align  = "LEFT",
				anchor = "TOPLEFT",
				xOfs   = -15,
				yOfs   = -188,
				shown  = "yes",
			},
			PctPower =
			{
				size   = 11,
				align  = "RIGHT",
				anchor = "TOPRIGHT",
				xOfs   = -20,
				yOfs   = -188,
				shown  = "yes",
			},
		},
	},

	Buffs =
	{
		Casts =
		{
			visible    = "yes",
			highlight  = "no",
			timers     = "yes",
			anim       = "yes",
			flash      = 10,
			flash_rate = 1.5,
			
			Shape =
			{
				orient = "TOPLEFT",
				grow   = "horizontal",
				rows   = 1,
				size   = 45,
				gap    = 1,
			},
			
			Origin =
			{
				anchor = "CENTER",
				xOfs   = 0,
				yOfs   = -290,
			},
		},
		Player =
		{
			visible    = "yes",
			highlight  = "yes",
			timers     = "yes",
			anim       = "yes",
			flash      = 10,
			flash_rate = 1.5,
			
			Shape =
			{
				orient = "TOPRIGHT",
				grow   = "vertical",
				rows   = 14,
				size   = 40,
				gap    = 1,
			},
			
			Origin =
			{
				anchor = "TOPRIGHT",
				xOfs   = -62,
				yOfs   = 130,
			},
		},
		Pet =
		{
			visible    = "yes",
			highlight  = "yes",
			timers     = "no",
			anim       = "yes",
			flash      = 0,
			flash_rate = 1.5,
			
			Shape =
			{
				orient = "TOPRIGHT",
				grow   = "vertical",
				rows   = 14,
				size   = 26,
				gap    = 1,
			},
			
			Origin =
			{
				anchor = "TOPRIGHT",
				xOfs   = -62,
				yOfs   = -40,
			},
		},
		Target =
		{
			visible    = "yes",
			highlight  = "yes",
			timers     = "yes",
			anim       = "yes",
			flash      = 10,
			flash_rate = 1.5,
			
			Shape =
			{
				orient = "TOPLEFT",
				grow   = "vertical",
				rows   = 14,
				size   = 40,
				gap    = 1,
			},
			
			Origin =
			{
				anchor = "TOPLEFT",
				xOfs   = 62,
				yOfs   = 130,
			},
		},
		ToT =
		{
			visible    = "yes",
			highlight  = "yes",
			timers     = "no",
			anim       = "yes",
			flash      = 0,
			flash_rate = 1.5,
			
			Shape =
			{
				orient = "TOPLEFT",
				grow   = "vertical",
				rows   = 14,
				size   = 26,
				gap    = 1,
			},
			
			Origin =
			{
				anchor = "TOPLEFT",
				xOfs   = 62,
				yOfs   = -40,
			},
		},
	},
	
	Colors =
	{
		Range = 
		{ 
			melee = { r = 1, g = 0.25, b = 0.25, },
			short = { r = 1, g = 1, b = 0.25, },
			med   = { r = 0.25, g = 1, b = 0.25, },
			long  = { r = 0.25, g = 1, b = 1, },
			oor   = { r = 1, g = 1, b = 1, },
		},
		Health = 
		{ 
			min = { r = 0.75, g = 0, b = 0, },
			mid = { r = 0.5, g = 0.5, b = 0, },
			max = { r = 0, g = 0.75, b = 0, },
		},
		Mana = 
		{ 
			min   = { r = 0.75, g = 0, b = 0.25, },
			mid   = { r = 0, g = 0, b = 0.6, },
			max   = { r = 0, g = 0, b = 1, },
		},
		Rage = 
		{ 
			min   = { r = 1, g = 0, b = 0, },
			mid   = { r = 1, g = 0, b = 0, },
			max   = { r = 1, g = 0, b = 0, },
		},
		Energy = 
		{ 
			min   = { r = 1, g = 1, b = 0, },
			mid   = { r = 1, g = 1, b = 0, },
			max   = { r = 1, g = 1, b = 0, },
		},
		Focus = 
		{ 
			min   = { r = 1, g = 0.4, b = 0, },
			mid   = { r = 1, g = 0.4, b = 0, },
			max   = { r = 1, g = 0.4, b = 0, },
		},
		Latency =
		{
			min   = { r = 0.25, g = 0.25, b = 1, },
			mid   = { r = 0.25, g = 0.25, b = 1, },
			max   = { r = 0.25, g = 0.25, b = 1, },
		},			
		Casting = 
		{ 
			min   = { r = 0.5, g = 0.5, b = 0, },
			mid   = { r = 0.5, g = 0.5, b = 0, },
			max   = { r = 0.5, g = 0.5, b = 0, },
		},
		Channeling = 
		{ 
			min   = { r = 0, g = 0.5, b = 0.5, a = 1, },
			mid   = { r = 0, g = 0.5, b = 0.5, a = 1, },
			max   = { r = 0, g = 0.5, b = 0.5, a = 1, },
		},
	},
}

nUI.Class.HUDLayout = nUI.Class:CreatePrototype();
local prototype     = nUI.Class.HUDLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function prototype:init( user_defined )
	
	if not user_defined then user_defined = {}; end
	if not user_defined.Origin then user_defined.Origin = {}; end
	if not user_defined.Alpha then user_defined.Alpha = {}; end
	if not user_defined.Bars then user_defined.Bars = {}; end
	if not user_defined.Bars.Cooldown then user_defined.Bars.Cooldown = {}; end
	if not user_defined.Bars.GCD then user_defined.Bars.GCD = {}; end
	if not user_defined.Bars.GCD.Color then user_defined.Bars.GCD.Color = {}; end
	if not user_defined.Bars.Player then user_defined.Bars.Player = {}; end
	if not user_defined.Bars.Player.Options then user_defined.Bars.Player.Options = {}; end
	if not user_defined.Bars.Player.Casting then user_defined.Bars.Player.Casting = {}; end
	if not user_defined.Bars.Player.Latency then user_defined.Bars.Player.Latency = {}; end
	if not user_defined.Bars.Player.Colors then user_defined.Bars.Player.Colors = {}; end
	if not user_defined.Bars.Player.Colors.Casting then user_defined.Bars.Player.Colors.Casting = {}; end
	if not user_defined.Bars.Player.Colors.Casting.max then user_defined.Bars.Player.Colors.Casting.max = {}; end
	if not user_defined.Bars.Player.Colors.Casting.mid then user_defined.Bars.Player.Colors.Casting.mid = {}; end
	if not user_defined.Bars.Player.Colors.Casting.min then user_defined.Bars.Player.Colors.Casting.min = {}; end
	if not user_defined.Bars.Player.Colors.Casting.bg then user_defined.Bars.Player.Colors.Casting.bg = {}; end
	if not user_defined.Bars.Player.Colors.Channeling then user_defined.Bars.Player.Colors.Channeling = {}; end
	if not user_defined.Bars.Player.Colors.Channeling.max then user_defined.Bars.Player.Colors.Channeling.max = {}; end
	if not user_defined.Bars.Player.Colors.Channeling.mid then user_defined.Bars.Player.Colors.Channeling.mid = {}; end
	if not user_defined.Bars.Player.Colors.Channeling.min then user_defined.Bars.Player.Colors.Channeling.min = {}; end
	if not user_defined.Bars.Player.Colors.Channeling.bg then user_defined.Bars.Player.Colors.Channeling.bg = {}; end
	if not user_defined.Bars.Player.Colors.Latency then user_defined.Bars.Player.Colors.Latency = {}; end
	if not user_defined.Bars.Player.Colors.Latency.max then user_defined.Bars.Player.Colors.Latency.max = {}; end
	if not user_defined.Bars.Player.Colors.Latency.mid then user_defined.Bars.Player.Colors.Latency.mid = {}; end
	if not user_defined.Bars.Player.Colors.Latency.min then user_defined.Bars.Player.Colors.Latency.min = {}; end
	if not user_defined.Bars.Player.Colors.Latency.bg then user_defined.Bars.Player.Colors.Latency.bg = {}; end
	if not user_defined.Bars.Target then user_defined.Bars.Target = {}; end
	if not user_defined.Bars.Target.Options then user_defined.Bars.Target.Options = {}; end
	if not user_defined.Bars.Target.Casting then user_defined.Bars.Target.Casting = {}; end
	if not user_defined.Bars.Target.Colors then user_defined.Bars.Target.Colors = {}; end
	if not user_defined.Bars.Target.Colors.Casting then user_defined.Bars.Target.Colors.Casting = {}; end
	if not user_defined.Bars.Target.Colors.Casting.max then user_defined.Bars.Target.Colors.Casting.max = {}; end
	if not user_defined.Bars.Target.Colors.Casting.mid then user_defined.Bars.Target.Colors.Casting.mid = {}; end
	if not user_defined.Bars.Target.Colors.Casting.min then user_defined.Bars.Target.Colors.Casting.min = {}; end
	if not user_defined.Bars.Target.Colors.Casting.bg then user_defined.Bars.Target.Colors.Casting.bg = {}; end
	if not user_defined.Bars.Target.Colors.Channeling then user_defined.Bars.Target.Colors.Channeling = {}; end
	if not user_defined.Bars.Target.Colors.Channeling.max then user_defined.Bars.Target.Colors.Channeling.max = {}; end
	if not user_defined.Bars.Target.Colors.Channeling.mid then user_defined.Bars.Target.Colors.Channeling.mid = {}; end
	if not user_defined.Bars.Target.Colors.Channeling.min then user_defined.Bars.Target.Colors.Channeling.min = {}; end
	if not user_defined.Bars.Target.Colors.Channeling.bg then user_defined.Bars.Target.Colors.Channeling.bg = {}; end
	if not user_defined.Labels then user_defined.Labels = {}; end
	if not user_defined.Labels.Range then user_defined.Labels.Range = {}; end
	if not user_defined.Labels.Player then user_defined.Labels.Player = {}; end
	if not user_defined.Labels.Player.MaxHealth then user_defined.Labels.Player.MaxHealth = {}; end
	if not user_defined.Labels.Player.CurHealth then user_defined.Labels.Player.CurHealth = {}; end
	if not user_defined.Labels.Player.PctHealth then user_defined.Labels.Player.PctHealth = {}; end
	if not user_defined.Labels.Player.MaxPower then user_defined.Labels.Player.MaxPower = {}; end
	if not user_defined.Labels.Player.CurPower then user_defined.Labels.Player.CurPower = {}; end
	if not user_defined.Labels.Player.PctPower then user_defined.Labels.Player.PctPower = {}; end
	if not user_defined.Labels.Pet then user_defined.Labels.Pet = {}; end
	if not user_defined.Labels.Pet.MaxHealth then user_defined.Labels.Pet.MaxHealth = {}; end
	if not user_defined.Labels.Pet.CurHealth then user_defined.Labels.Pet.CurHealth = {}; end
	if not user_defined.Labels.Pet.PctHealth then user_defined.Labels.Pet.PctHealth = {}; end
	if not user_defined.Labels.Pet.MaxPower then user_defined.Labels.Pet.MaxPower = {}; end
	if not user_defined.Labels.Pet.CurPower then user_defined.Labels.Pet.CurPower = {}; end
	if not user_defined.Labels.Pet.PctPower then user_defined.Labels.Pet.PctPower = {}; end
	if not user_defined.Labels.Target then user_defined.Labels.Target = {}; end
	if not user_defined.Labels.Target.MaxHealth then user_defined.Labels.Target.MaxHealth = {}; end
	if not user_defined.Labels.Target.CurHealth then user_defined.Labels.Target.CurHealth = {}; end
	if not user_defined.Labels.Target.PctHealth then user_defined.Labels.Target.PctHealth = {}; end
	if not user_defined.Labels.Target.MaxPower then user_defined.Labels.Target.MaxPower = {}; end
	if not user_defined.Labels.Target.CurPower then user_defined.Labels.Target.CurPower = {}; end
	if not user_defined.Labels.Target.PctPower then user_defined.Labels.Target.PctPower = {}; end	
	if not user_defined.Labels.ToT then user_defined.Labels.ToT = {}; end
	if not user_defined.Labels.ToT.MaxHealth then user_defined.Labels.ToT.MaxHealth = {}; end
	if not user_defined.Labels.ToT.CurHealth then user_defined.Labels.ToT.CurHealth = {}; end
	if not user_defined.Labels.ToT.PctHealth then user_defined.Labels.ToT.PctHealth = {}; end
	if not user_defined.Labels.ToT.MaxPower then user_defined.Labels.ToT.MaxPower = {}; end
	if not user_defined.Labels.ToT.CurPower then user_defined.Labels.ToT.CurPower = {}; end
	if not user_defined.Labels.ToT.PctPower then user_defined.Labels.ToT.PctPower = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.Range then user_defined.Colors.Range = {}; end
	if not user_defined.Colors.Range.melee then user_defined.Colors.Range.melee = {}; end
	if not user_defined.Colors.Range.short then user_defined.Colors.Range.short = {}; end
	if not user_defined.Colors.Range.med then user_defined.Colors.Range.med = {}; end
	if not user_defined.Colors.Range.long then user_defined.Colors.Range.long = {}; end
	if not user_defined.Colors.Range.oor then user_defined.Colors.Range.oor = {}; end
	if not user_defined.Colors.Health then user_defined.Colors.Health = {}; end
	if not user_defined.Colors.Health.min then user_defined.Colors.Health.min = {}; end
	if not user_defined.Colors.Health.mid then user_defined.Colors.Health.mid = {}; end
	if not user_defined.Colors.Health.max then user_defined.Colors.Health.max = {}; end
	if not user_defined.Colors.Mana then user_defined.Colors.Mana = {}; end
	if not user_defined.Colors.Mana.min then user_defined.Colors.Mana.min = {}; end
	if not user_defined.Colors.Mana.mid then user_defined.Colors.Mana.mid = {}; end
	if not user_defined.Colors.Mana.max then user_defined.Colors.Mana.max = {}; end
	if not user_defined.Colors.Rage then user_defined.Colors.Rage = {}; end
	if not user_defined.Colors.Rage.min then user_defined.Colors.Rage.min = {}; end
	if not user_defined.Colors.Rage.mid then user_defined.Colors.Rage.mid = {}; end
	if not user_defined.Colors.Rage.max then user_defined.Colors.Rage.max = {}; end
	if not user_defined.Colors.Energy then user_defined.Colors.Energy = {}; end
	if not user_defined.Colors.Energy.min then user_defined.Colors.Energy.min = {}; end
	if not user_defined.Colors.Energy.mid then user_defined.Colors.Energy.mid = {}; end
	if not user_defined.Colors.Energy.max then user_defined.Colors.Energy.max = {}; end
	if not user_defined.Colors.Focus then user_defined.Colors.Focus = {}; end
	if not user_defined.Colors.Focus.min then user_defined.Colors.Focus.min = {}; end
	if not user_defined.Colors.Focus.mid then user_defined.Colors.Focus.mid = {}; end
	if not user_defined.Colors.Focus.max then user_defined.Colors.Focus.max = {}; end
	if not user_defined.Colors.Latency then user_defined.Colors.Latency = {}; end
	if not user_defined.Colors.Latency.min then user_defined.Colors.Latency.min = {}; end
	if not user_defined.Colors.Latency.mid then user_defined.Colors.Latency.mid = {}; end
	if not user_defined.Colors.Latency.max then user_defined.Colors.Latency.max = {}; end
	if not user_defined.Colors.Casting then user_defined.Colors.Casting = {}; end
	if not user_defined.Colors.Casting.min then user_defined.Colors.Casting.min = {}; end
	if not user_defined.Colors.Casting.mid then user_defined.Colors.Casting.mid = {}; end
	if not user_defined.Colors.Casting.max then user_defined.Colors.Casting.max = {}; end
	if not user_defined.Colors.Channeling then user_defined.Colors.Channeling = {}; end
	if not user_defined.Colors.Channeling.min then user_defined.Colors.Channeling.min = {}; end
	if not user_defined.Colors.Channeling.mid then user_defined.Colors.Channeling.mid = {}; end
	if not user_defined.Colors.Channeling.max then user_defined.Colors.Channeling.max = {}; end
	if not user_defined.Buffs then user_defined.Buffs = {}; end
	if not user_defined.Buffs.Casts then user_defined.Buffs.Casts = {}; end
	if not user_defined.Buffs.Casts.Origin then user_defined.Buffs.Casts.Origin = {}; end
	if not user_defined.Buffs.Casts.Shape then user_defined.Buffs.Casts.Shape = {}; end
	if not user_defined.Buffs.Player then user_defined.Buffs.Player = {}; end
	if not user_defined.Buffs.Player.Origin then user_defined.Buffs.Player.Origin = {}; end
	if not user_defined.Buffs.Player.Shape then user_defined.Buffs.Player.Shape = {}; end
	if not user_defined.Buffs.Pet then user_defined.Buffs.Pet = {}; end
	if not user_defined.Buffs.Pet.Origin then user_defined.Buffs.Pet.Origin = {}; end
	if not user_defined.Buffs.Pet.Shape then user_defined.Buffs.Pet.Shape = {}; end
	if not user_defined.Buffs.Target then user_defined.Buffs.Target = {}; end
	if not user_defined.Buffs.Target.Origin then user_defined.Buffs.Target.Origin = {}; end
	if not user_defined.Buffs.Target.Shape then user_defined.Buffs.Target.Shape = {}; end
	if not user_defined.Buffs.ToT then user_defined.Buffs.ToT = {}; end
	if not user_defined.Buffs.ToT.Origin then user_defined.Buffs.ToT.Origin = {}; end
	if not user_defined.Buffs.ToT.Shape then user_defined.Buffs.ToT.Shape = {}; end
	
	self.scale        = tonumber( user_defined.scale or nUI_HUDLayout.scale );
	self.spacing      = tonumber( user_defined.spacing or nUI_HUDLayout.spacing );
	self.font_size    = tonumber( user_defined.font_size or nUI_HUDLayout.font_size );
	self.show_borders = strlower( user_defined.show_borders or nUI_HUDLayout.show_borders );
	self.show_npc     = strlower( user_defined.show_npc or nUI_HUDLayout.show_npc );

	self.Bars =
	{
		Cooldown =
		{
			size   = tonumber( user_defined.Bars.Cooldown.size or nUI_HUDLayout.Bars.Cooldown.size ),
			gap    = tonumber( user_defined.Bars.Cooldown.gap or nUI_HUDLayout.Bars.Cooldown.gap ),
			anchor = strupper( user_defined.Bars.Cooldown.anchor or nUI_HUDLayout.Bars.Cooldown.anchor ),
			xOfs   = tonumber( user_defined.Bars.Cooldown.xOfs or nUI_HUDLayout.Bars.Cooldown.xOfs ),
			yOfs   = tonumber( user_defined.Bars.Cooldown.yOfs or nUI_HUDLayout.Bars.Cooldown.yOfs ),
			shown  = strlower( user_defined.Bars.Cooldown.shown or nUI_HUDLayout.Bars.Cooldown.shown ),
		},

		GCD =
		{
			size    = tonumber( user_defined.Bars.GCD.size or nUI_HUDLayout.Bars.GCD.size ),
			latency = strlower( user_defined.Bars.GCD.latency or nUI_HUDLayout.Bars.GCD.latency ),
			anchor  = strupper( user_defined.Bars.GCD.anchor or nUI_HUDLayout.Bars.GCD.anchor ),
			xOfs    = tonumber( user_defined.Bars.GCD.xOfs or nUI_HUDLayout.Bars.GCD.xOfs ),
			yOfs    = tonumber( user_defined.Bars.GCD.yOfs or nUI_HUDLayout.Bars.GCD.yOfs ),
			shown   = strlower( user_defined.Bars.GCD.shown or nUI_HUDLayout.Bars.GCD.shown ),
			Color   =
			{
				r = tonumber( user_defined.Bars.GCD.Color.g or nUI_HUDLayout.Bars.GCD.Color.r ),
				g = tonumber( user_defined.Bars.GCD.Color.g or nUI_HUDLayout.Bars.GCD.Color.g ),
				b = tonumber( user_defined.Bars.GCD.Color.b or nUI_HUDLayout.Bars.GCD.Color.b ),
				a = tonumber( user_defined.Bars.GCD.Color.a or nUI_HUDLayout.Bars.GCD.Color.a ),
			},
		},		
		
		Player =
		{
			Options =
			{
				show_name = strlower( user_defined.Bars.Player.Options.show_name or nUI_HUDLayout.Bars.Player.Options.show_name ),
				cur_value = strlower( user_defined.Bars.Player.Options.cur_value or nUI_HUDLayout.Bars.Player.Options.cur_value ),
				max_value = strlower( user_defined.Bars.Player.Options.max_value or nUI_HUDLayout.Bars.Player.Options.max_value ),
				min_value = strlower( user_defined.Bars.Player.Options.min_value or nUI_HUDLayout.Bars.Player.Options.min_value ),
				percent   = strlower( user_defined.Bars.Player.Options.percent or nUI_HUDLayout.Bars.Player.Options.percent ),
				grow      = strlower( user_defined.Bars.Player.Options.grow or nUI_HUDLayout.Bars.Player.Options.grow ),
			},
			Casting =
			{
				visible = strlower( user_defined.Bars.Player.Casting.visible or nUI_HUDLayout.Bars.Player.Casting.visible),
				pet     = strlower( user_defined.Bars.Player.Casting.pet or nUI_HUDLayout.Bars.Player.Casting.pet),
				anchor  = strupper( user_defined.Bars.Player.Casting.anchor or nUI_HUDLayout.Bars.Player.Casting.anchor),
				xOfs    = tonumber( user_defined.Bars.Player.Casting.xOfs or nUI_HUDLayout.Bars.Player.Casting.xOfs),
				yOfs    = tonumber( user_defined.Bars.Player.Casting.yOfs or nUI_HUDLayout.Bars.Player.Casting.yOfs),
				width   = tonumber( user_defined.Bars.Player.Casting.width or nUI_HUDLayout.Bars.Player.Casting.width),
				height  = tonumber( user_defined.Bars.Player.Casting.height or nUI_HUDLayout.Bars.Player.Casting.height),
			},
			Latency =
			{
				visible = strlower( user_defined.Bars.Player.Latency.visible or nUI_HUDLayout.Bars.Player.Latency.visible),
				height  = tonumber( user_defined.Bars.Player.Latency.height or nUI_HUDLayout.Bars.Player.Latency.height),
			},
			Colors =
			{
				Casting = 
				{
					min = 
					{
						r = user_defined.Bars.Player.Colors.Casting.min.r or nUI_HUDLayout.Bars.Player.Colors.Casting.min.r,
						g = user_defined.Bars.Player.Colors.Casting.min.g or nUI_HUDLayout.Bars.Player.Colors.Casting.min.g,
						b = user_defined.Bars.Player.Colors.Casting.min.b or nUI_HUDLayout.Bars.Player.Colors.Casting.min.b,
						a = user_defined.Bars.Player.Colors.Casting.min.a or nUI_HUDLayout.Bars.Player.Colors.Casting.min.a,
					},
					mid = 
					{
						r = user_defined.Bars.Player.Colors.Casting.mid.r or nUI_HUDLayout.Bars.Player.Colors.Casting.mid.r,
						g = user_defined.Bars.Player.Colors.Casting.mid.g or nUI_HUDLayout.Bars.Player.Colors.Casting.mid.g,
						b = user_defined.Bars.Player.Colors.Casting.mid.b or nUI_HUDLayout.Bars.Player.Colors.Casting.mid.b,
						a = user_defined.Bars.Player.Colors.Casting.mid.a or nUI_HUDLayout.Bars.Player.Colors.Casting.mid.a,
					},
					max = 
					{
						r = user_defined.Bars.Player.Colors.Casting.max.r or nUI_HUDLayout.Bars.Player.Colors.Casting.max.r,
						g = user_defined.Bars.Player.Colors.Casting.max.g or nUI_HUDLayout.Bars.Player.Colors.Casting.max.g,
						b = user_defined.Bars.Player.Colors.Casting.max.b or nUI_HUDLayout.Bars.Player.Colors.Casting.max.b,
						a = user_defined.Bars.Player.Colors.Casting.max.a or nUI_HUDLayout.Bars.Player.Colors.Casting.max.a,
					},
					bg  = 
					{ 
						r = user_defined.Bars.Player.Colors.Casting.bg.r or nUI_HUDLayout.Bars.Player.Colors.Casting.bg.r,
						g = user_defined.Bars.Player.Colors.Casting.bg.g or nUI_HUDLayout.Bars.Player.Colors.Casting.bg.g,
						b = user_defined.Bars.Player.Colors.Casting.bg.b or nUI_HUDLayout.Bars.Player.Colors.Casting.bg.b,
						a = user_defined.Bars.Player.Colors.Casting.bg.a or nUI_HUDLayout.Bars.Player.Colors.Casting.bg.a,
					},
				},
				Channeling =
				{
					min = 
					{
						r = user_defined.Bars.Player.Colors.Channeling.min.r or nUI_HUDLayout.Bars.Player.Colors.Channeling.min.r,
						g = user_defined.Bars.Player.Colors.Channeling.min.g or nUI_HUDLayout.Bars.Player.Colors.Channeling.min.g,
						b = user_defined.Bars.Player.Colors.Channeling.min.b or nUI_HUDLayout.Bars.Player.Colors.Channeling.min.b,
						a = user_defined.Bars.Player.Colors.Channeling.min.a or nUI_HUDLayout.Bars.Player.Colors.Channeling.min.a,
					},
					mid = 
					{
						r = user_defined.Bars.Player.Colors.Channeling.mid.r or nUI_HUDLayout.Bars.Player.Colors.Channeling.mid.r,
						g = user_defined.Bars.Player.Colors.Channeling.mid.g or nUI_HUDLayout.Bars.Player.Colors.Channeling.mid.g,
						b = user_defined.Bars.Player.Colors.Channeling.mid.b or nUI_HUDLayout.Bars.Player.Colors.Channeling.mid.b,
						a = user_defined.Bars.Player.Colors.Channeling.mid.a or nUI_HUDLayout.Bars.Player.Colors.Channeling.mid.a,
					},
					max = 
					{
						r = user_defined.Bars.Player.Colors.Channeling.max.r or nUI_HUDLayout.Bars.Player.Colors.Channeling.max.r,
						g = user_defined.Bars.Player.Colors.Channeling.max.g or nUI_HUDLayout.Bars.Player.Colors.Channeling.max.g,
						b = user_defined.Bars.Player.Colors.Channeling.max.b or nUI_HUDLayout.Bars.Player.Colors.Channeling.max.b,
						a = user_defined.Bars.Player.Colors.Channeling.max.a or nUI_HUDLayout.Bars.Player.Colors.Channeling.max.a,
					},
					bg  = 
					{ 
						r = user_defined.Bars.Player.Colors.Channeling.bg.r or nUI_HUDLayout.Bars.Player.Colors.Channeling.bg.r,
						g = user_defined.Bars.Player.Colors.Channeling.bg.g or nUI_HUDLayout.Bars.Player.Colors.Channeling.bg.g,
						b = user_defined.Bars.Player.Colors.Channeling.bg.b or nUI_HUDLayout.Bars.Player.Colors.Channeling.bg.b,
						a = user_defined.Bars.Player.Colors.Channeling.bg.a or nUI_HUDLayout.Bars.Player.Colors.Channeling.bg.a,
					},
				},
				Latency =
				{
					min = 
					{
						r = user_defined.Bars.Player.Colors.Latency.min.r or nUI_HUDLayout.Bars.Player.Colors.Latency.min.r,
						g = user_defined.Bars.Player.Colors.Latency.min.g or nUI_HUDLayout.Bars.Player.Colors.Latency.min.g,
						b = user_defined.Bars.Player.Colors.Latency.min.b or nUI_HUDLayout.Bars.Player.Colors.Latency.min.b,
						a = user_defined.Bars.Player.Colors.Latency.min.a or nUI_HUDLayout.Bars.Player.Colors.Latency.min.a,
					},
					mid = 
					{
						r = user_defined.Bars.Player.Colors.Latency.mid.r or nUI_HUDLayout.Bars.Player.Colors.Latency.mid.r,
						g = user_defined.Bars.Player.Colors.Latency.mid.g or nUI_HUDLayout.Bars.Player.Colors.Latency.mid.g,
						b = user_defined.Bars.Player.Colors.Latency.mid.b or nUI_HUDLayout.Bars.Player.Colors.Latency.mid.b,
						a = user_defined.Bars.Player.Colors.Latency.mid.a or nUI_HUDLayout.Bars.Player.Colors.Latency.mid.a,
					},
					max = 
					{
						r = user_defined.Bars.Player.Colors.Latency.max.r or nUI_HUDLayout.Bars.Player.Colors.Latency.max.r,
						g = user_defined.Bars.Player.Colors.Latency.max.g or nUI_HUDLayout.Bars.Player.Colors.Latency.max.g,
						b = user_defined.Bars.Player.Colors.Latency.max.b or nUI_HUDLayout.Bars.Player.Colors.Latency.max.b,
						a = user_defined.Bars.Player.Colors.Latency.max.a or nUI_HUDLayout.Bars.Player.Colors.Latency.max.a,
					},
					bg  = 
					{ 
						r = user_defined.Bars.Player.Colors.Latency.bg.r or nUI_HUDLayout.Bars.Player.Colors.Latency.bg.r,
						g = user_defined.Bars.Player.Colors.Latency.bg.g or nUI_HUDLayout.Bars.Player.Colors.Latency.bg.g,
						b = user_defined.Bars.Player.Colors.Latency.bg.b or nUI_HUDLayout.Bars.Player.Colors.Latency.bg.b,
						a = user_defined.Bars.Player.Colors.Latency.bg.a or nUI_HUDLayout.Bars.Player.Colors.Latency.bg.a,
					},
				},
			},
		},
		
		Target =
		{
			Options =
			{
				show_name = strlower( user_defined.Bars.Target.Options.show_name or nUI_HUDLayout.Bars.Target.Options.show_name ),
				cur_value = strlower( user_defined.Bars.Target.Options.cur_value or nUI_HUDLayout.Bars.Target.Options.cur_value ),
				max_value = strlower( user_defined.Bars.Target.Options.max_value or nUI_HUDLayout.Bars.Target.Options.max_value ),
				min_value = strlower( user_defined.Bars.Target.Options.min_value or nUI_HUDLayout.Bars.Target.Options.min_value ),
				percent   = strlower( user_defined.Bars.Target.Options.percent or nUI_HUDLayout.Bars.Target.Options.percent ),
				grow      = strlower( user_defined.Bars.Target.Options.grow or nUI_HUDLayout.Bars.Target.Options.grow ),
			},
			Casting =
			{
				visible = strlower( user_defined.Bars.Target.Casting.visible or nUI_HUDLayout.Bars.Target.Casting.visible),
				anchor  = strupper( user_defined.Bars.Target.Casting.anchor or nUI_HUDLayout.Bars.Target.Casting.anchor),
				xOfs    = tonumber( user_defined.Bars.Target.Casting.xOfs or nUI_HUDLayout.Bars.Target.Casting.xOfs),
				yOfs    = tonumber( user_defined.Bars.Target.Casting.yOfs or nUI_HUDLayout.Bars.Target.Casting.yOfs),
				width   = tonumber( user_defined.Bars.Target.Casting.width or nUI_HUDLayout.Bars.Target.Casting.width),
				height  = tonumber( user_defined.Bars.Target.Casting.height or nUI_HUDLayout.Bars.Target.Casting.height),
			},
			Colors =
			{
				Casting = 
				{
					min = 
					{
						r = user_defined.Bars.Target.Colors.Casting.min.r or nUI_HUDLayout.Bars.Target.Colors.Casting.min.r,
						g = user_defined.Bars.Target.Colors.Casting.min.g or nUI_HUDLayout.Bars.Target.Colors.Casting.min.g,
						b = user_defined.Bars.Target.Colors.Casting.min.b or nUI_HUDLayout.Bars.Target.Colors.Casting.min.b,
						a = user_defined.Bars.Target.Colors.Casting.min.a or nUI_HUDLayout.Bars.Target.Colors.Casting.min.a,
					},
					mid = 
					{
						r = user_defined.Bars.Target.Colors.Casting.mid.r or nUI_HUDLayout.Bars.Target.Colors.Casting.mid.r,
						g = user_defined.Bars.Target.Colors.Casting.mid.g or nUI_HUDLayout.Bars.Target.Colors.Casting.mid.g,
						b = user_defined.Bars.Target.Colors.Casting.mid.b or nUI_HUDLayout.Bars.Target.Colors.Casting.mid.b,
						a = user_defined.Bars.Target.Colors.Casting.mid.a or nUI_HUDLayout.Bars.Target.Colors.Casting.mid.a,
					},
					max = 
					{
						r = user_defined.Bars.Target.Colors.Casting.max.r or nUI_HUDLayout.Bars.Target.Colors.Casting.max.r,
						g = user_defined.Bars.Target.Colors.Casting.max.g or nUI_HUDLayout.Bars.Target.Colors.Casting.max.g,
						b = user_defined.Bars.Target.Colors.Casting.max.b or nUI_HUDLayout.Bars.Target.Colors.Casting.max.b,
						a = user_defined.Bars.Target.Colors.Casting.max.a or nUI_HUDLayout.Bars.Target.Colors.Casting.max.a,
					},
					bg  = 
					{ 
						r = user_defined.Bars.Target.Colors.Casting.bg.r or nUI_HUDLayout.Bars.Target.Colors.Casting.bg.r,
						g = user_defined.Bars.Target.Colors.Casting.bg.g or nUI_HUDLayout.Bars.Target.Colors.Casting.bg.g,
						b = user_defined.Bars.Target.Colors.Casting.bg.b or nUI_HUDLayout.Bars.Target.Colors.Casting.bg.b,
						a = user_defined.Bars.Target.Colors.Casting.bg.a or nUI_HUDLayout.Bars.Target.Colors.Casting.bg.a,
					},
				},
				Channeling =
				{
					min = 
					{
						r = user_defined.Bars.Target.Colors.Channeling.min.r or nUI_HUDLayout.Bars.Target.Colors.Channeling.min.r,
						g = user_defined.Bars.Target.Colors.Channeling.min.g or nUI_HUDLayout.Bars.Target.Colors.Channeling.min.g,
						b = user_defined.Bars.Target.Colors.Channeling.min.b or nUI_HUDLayout.Bars.Target.Colors.Channeling.min.b,
						a = user_defined.Bars.Target.Colors.Channeling.min.a or nUI_HUDLayout.Bars.Target.Colors.Channeling.min.a,
					},
					mid = 
					{
						r = user_defined.Bars.Target.Colors.Channeling.mid.r or nUI_HUDLayout.Bars.Target.Colors.Channeling.mid.r,
						g = user_defined.Bars.Target.Colors.Channeling.mid.g or nUI_HUDLayout.Bars.Target.Colors.Channeling.mid.g,
						b = user_defined.Bars.Target.Colors.Channeling.mid.b or nUI_HUDLayout.Bars.Target.Colors.Channeling.mid.b,
						a = user_defined.Bars.Target.Colors.Channeling.mid.a or nUI_HUDLayout.Bars.Target.Colors.Channeling.mid.a,
					},
					max = 
					{
						r = user_defined.Bars.Target.Colors.Channeling.max.r or nUI_HUDLayout.Bars.Target.Colors.Channeling.max.r,
						g = user_defined.Bars.Target.Colors.Channeling.max.g or nUI_HUDLayout.Bars.Target.Colors.Channeling.max.g,
						b = user_defined.Bars.Target.Colors.Channeling.max.b or nUI_HUDLayout.Bars.Target.Colors.Channeling.max.b,
						a = user_defined.Bars.Target.Colors.Channeling.max.a or nUI_HUDLayout.Bars.Target.Colors.Channeling.max.a,
					},
					bg  = 
					{ 
						r = user_defined.Bars.Target.Colors.Channeling.bg.r or nUI_HUDLayout.Bars.Target.Colors.Channeling.bg.r,
						g = user_defined.Bars.Target.Colors.Channeling.bg.g or nUI_HUDLayout.Bars.Target.Colors.Channeling.bg.g,
						b = user_defined.Bars.Target.Colors.Channeling.bg.b or nUI_HUDLayout.Bars.Target.Colors.Channeling.bg.b,
						a = user_defined.Bars.Target.Colors.Channeling.bg.a or nUI_HUDLayout.Bars.Target.Colors.Channeling.bg.a,
					},
				},
			},
		},
	};
	
	self.Labels =
	{
		Range =
		{
			size   = tonumber( user_defined.Labels.Range.size or nUI_HUDLayout.Labels.Range.size ),
			align  = strupper( user_defined.Labels.Range.align or nUI_HUDLayout.Labels.Range.align ),
			anchor = strupper( user_defined.Labels.Range.anchor or nUI_HUDLayout.Labels.Range.anchor ),
			xOfs   = tonumber( user_defined.Labels.Range.xOfs or nUI_HUDLayout.Labels.Range.xOfs ),
			yOfs   = tonumber( user_defined.Labels.Range.yOfs or nUI_HUDLayout.Labels.Range.yOfs ),
			shown  = strlower( user_defined.Labels.Range.shown or nUI_HUDLayout.Labels.Range.shown ),
		},
		Player =
		{
			MaxHealth =
			{
				size   = tonumber( user_defined.Labels.Player.MaxHealth.size or nUI_HUDLayout.Labels.Player.MaxHealth.size ),
				align  = strupper( user_defined.Labels.Player.MaxHealth.align or nUI_HUDLayout.Labels.Player.MaxHealth.align ),
				anchor = strupper( user_defined.Labels.Player.MaxHealth.anchor or nUI_HUDLayout.Labels.Player.MaxHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.MaxHealth.xOfs or nUI_HUDLayout.Labels.Player.MaxHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.MaxHealth.yOfs or nUI_HUDLayout.Labels.Player.MaxHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Player.MaxHealth.shown or nUI_HUDLayout.Labels.Player.MaxHealth.shown ),
			},
			CurHealth =
			{
				size   = tonumber( user_defined.Labels.Player.CurHealth.size or nUI_HUDLayout.Labels.Player.CurHealth.size ),
				align  = strupper( user_defined.Labels.Player.CurHealth.align or nUI_HUDLayout.Labels.Player.CurHealth.align ),
				anchor = strupper( user_defined.Labels.Player.CurHealth.anchor or nUI_HUDLayout.Labels.Player.CurHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.CurHealth.xOfs or nUI_HUDLayout.Labels.Player.CurHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.CurHealth.yOfs or nUI_HUDLayout.Labels.Player.CurHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Player.CurHealth.shown or nUI_HUDLayout.Labels.Player.CurHealth.shown ),
			},
			PctHealth =
			{
				size   = tonumber( user_defined.Labels.Player.PctHealth.size or nUI_HUDLayout.Labels.Player.PctHealth.size ),
				align  = strupper( user_defined.Labels.Player.PctHealth.align or nUI_HUDLayout.Labels.Player.PctHealth.align ),
				anchor = strupper( user_defined.Labels.Player.PctHealth.anchor or nUI_HUDLayout.Labels.Player.PctHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.PctHealth.xOfs or nUI_HUDLayout.Labels.Player.PctHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.PctHealth.yOfs or nUI_HUDLayout.Labels.Player.PctHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Player.PctHealth.shown or nUI_HUDLayout.Labels.Player.PctHealth.shown ),
			},
			MaxPower =
			{
				size   = tonumber( user_defined.Labels.Player.MaxPower.size or nUI_HUDLayout.Labels.Player.MaxPower.size ),
				align  = strupper( user_defined.Labels.Player.MaxPower.align or nUI_HUDLayout.Labels.Player.MaxPower.align ),
				anchor = strupper( user_defined.Labels.Player.MaxPower.anchor or nUI_HUDLayout.Labels.Player.MaxPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.MaxPower.xOfs or nUI_HUDLayout.Labels.Player.MaxPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.MaxPower.yOfs or nUI_HUDLayout.Labels.Player.MaxPower.yOfs ),
				shown  = strlower( user_defined.Labels.Player.MaxPower.shown or nUI_HUDLayout.Labels.Player.MaxPower.shown ),
			},
			CurPower =
			{
				size   = tonumber( user_defined.Labels.Player.CurPower.size or nUI_HUDLayout.Labels.Player.CurPower.size ),
				align  = strupper( user_defined.Labels.Player.CurPower.align or nUI_HUDLayout.Labels.Player.CurPower.align ),
				anchor = strupper( user_defined.Labels.Player.CurPower.anchor or nUI_HUDLayout.Labels.Player.CurPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.CurPower.xOfs or nUI_HUDLayout.Labels.Player.CurPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.CurPower.yOfs or nUI_HUDLayout.Labels.Player.CurPower.yOfs ),
				shown  = strlower( user_defined.Labels.Player.CurPower.shown or nUI_HUDLayout.Labels.Player.CurPower.shown ),
			},
			PctPower =
			{
				size   = tonumber( user_defined.Labels.Player.PctPower.size or nUI_HUDLayout.Labels.Player.PctPower.size ),
				align  = strupper( user_defined.Labels.Player.PctPower.align or nUI_HUDLayout.Labels.Player.PctPower.align ),
				anchor = strupper( user_defined.Labels.Player.PctPower.anchor or nUI_HUDLayout.Labels.Player.PctPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Player.PctPower.xOfs or nUI_HUDLayout.Labels.Player.PctPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Player.PctPower.yOfs or nUI_HUDLayout.Labels.Player.PctPower.yOfs ),
				shown  = strlower( user_defined.Labels.Player.PctPower.shown or nUI_HUDLayout.Labels.Player.PctPower.shown ),
			},
		},
		Pet =
		{
			MaxHealth =
			{
				size   = tonumber( user_defined.Labels.Pet.MaxHealth.size or nUI_HUDLayout.Labels.Pet.MaxHealth.size ),
				align  = strupper( user_defined.Labels.Pet.MaxHealth.align or nUI_HUDLayout.Labels.Pet.MaxHealth.align ),
				anchor = strupper( user_defined.Labels.Pet.MaxHealth.anchor or nUI_HUDLayout.Labels.Pet.MaxHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.MaxHealth.xOfs or nUI_HUDLayout.Labels.Pet.MaxHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.MaxHealth.yOfs or nUI_HUDLayout.Labels.Pet.MaxHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.MaxHealth.shown or nUI_HUDLayout.Labels.Pet.MaxHealth.shown ),
			},
			CurHealth =
			{
				size   = tonumber( user_defined.Labels.Pet.CurHealth.size or nUI_HUDLayout.Labels.Pet.CurHealth.size ),
				align  = strupper( user_defined.Labels.Pet.CurHealth.align or nUI_HUDLayout.Labels.Pet.CurHealth.align ),
				anchor = strupper( user_defined.Labels.Pet.CurHealth.anchor or nUI_HUDLayout.Labels.Pet.CurHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.CurHealth.xOfs or nUI_HUDLayout.Labels.Pet.CurHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.CurHealth.yOfs or nUI_HUDLayout.Labels.Pet.CurHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.CurHealth.shown or nUI_HUDLayout.Labels.Pet.CurHealth.shown ),
			},
			PctHealth =
			{
				size   = tonumber( user_defined.Labels.Pet.PctHealth.size or nUI_HUDLayout.Labels.Pet.PctHealth.size ),
				align  = strupper( user_defined.Labels.Pet.PctHealth.align or nUI_HUDLayout.Labels.Pet.PctHealth.align ),
				anchor = strupper( user_defined.Labels.Pet.PctHealth.anchor or nUI_HUDLayout.Labels.Pet.PctHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.PctHealth.xOfs or nUI_HUDLayout.Labels.Pet.PctHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.PctHealth.yOfs or nUI_HUDLayout.Labels.Pet.PctHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.PctHealth.shown or nUI_HUDLayout.Labels.Pet.PctHealth.shown ),
			},
			MaxPower =
			{
				size   = tonumber( user_defined.Labels.Pet.MaxPower.size or nUI_HUDLayout.Labels.Pet.MaxPower.size ),
				align  = strupper( user_defined.Labels.Pet.MaxPower.align or nUI_HUDLayout.Labels.Pet.MaxPower.align ),
				anchor = strupper( user_defined.Labels.Pet.MaxPower.anchor or nUI_HUDLayout.Labels.Pet.MaxPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.MaxPower.xOfs or nUI_HUDLayout.Labels.Pet.MaxPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.MaxPower.yOfs or nUI_HUDLayout.Labels.Pet.MaxPower.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.MaxPower.shown or nUI_HUDLayout.Labels.Pet.MaxPower.shown ),
			},
			CurPower =
			{
				size   = tonumber( user_defined.Labels.Pet.CurPower.size or nUI_HUDLayout.Labels.Pet.CurPower.size ),
				align  = strupper( user_defined.Labels.Pet.CurPower.align or nUI_HUDLayout.Labels.Pet.CurPower.align ),
				anchor = strupper( user_defined.Labels.Pet.CurPower.anchor or nUI_HUDLayout.Labels.Pet.CurPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.CurPower.xOfs or nUI_HUDLayout.Labels.Pet.CurPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.CurPower.yOfs or nUI_HUDLayout.Labels.Pet.CurPower.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.CurPower.shown or nUI_HUDLayout.Labels.Pet.CurPower.shown ),
			},
			PctPower =
			{
				size   = tonumber( user_defined.Labels.Pet.PctPower.size or nUI_HUDLayout.Labels.Pet.PctPower.size ),
				align  = strupper( user_defined.Labels.Pet.PctPower.align or nUI_HUDLayout.Labels.Pet.PctPower.align ),
				anchor = strupper( user_defined.Labels.Pet.PctPower.anchor or nUI_HUDLayout.Labels.Pet.PctPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Pet.PctPower.xOfs or nUI_HUDLayout.Labels.Pet.PctPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Pet.PctPower.yOfs or nUI_HUDLayout.Labels.Pet.PctPower.yOfs ),
				shown  = strlower( user_defined.Labels.Pet.PctPower.shown or nUI_HUDLayout.Labels.Pet.PctPower.shown ),
			},
		},
		Target =
		{
			MaxHealth =
			{
				size   = tonumber( user_defined.Labels.Target.MaxHealth.size or nUI_HUDLayout.Labels.Target.MaxHealth.size ),
				align  = strupper( user_defined.Labels.Target.MaxHealth.align or nUI_HUDLayout.Labels.Target.MaxHealth.align ),
				anchor = strupper( user_defined.Labels.Target.MaxHealth.anchor or nUI_HUDLayout.Labels.Target.MaxHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.MaxHealth.xOfs or nUI_HUDLayout.Labels.Target.MaxHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.MaxHealth.yOfs or nUI_HUDLayout.Labels.Target.MaxHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Target.MaxHealth.shown or nUI_HUDLayout.Labels.Target.MaxHealth.shown ),
			},
			CurHealth =
			{
				size   = tonumber( user_defined.Labels.Target.CurHealth.size or nUI_HUDLayout.Labels.Target.CurHealth.size ),
				align  = strupper( user_defined.Labels.Target.CurHealth.align or nUI_HUDLayout.Labels.Target.CurHealth.align ),
				anchor = strupper( user_defined.Labels.Target.CurHealth.anchor or nUI_HUDLayout.Labels.Target.CurHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.CurHealth.xOfs or nUI_HUDLayout.Labels.Target.CurHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.CurHealth.yOfs or nUI_HUDLayout.Labels.Target.CurHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Target.CurHealth.shown or nUI_HUDLayout.Labels.Target.CurHealth.shown ),
			},
			PctHealth =
			{
				size   = tonumber( user_defined.Labels.Target.PctHealth.size or nUI_HUDLayout.Labels.Target.PctHealth.size ),
				align  = strupper( user_defined.Labels.Target.PctHealth.align or nUI_HUDLayout.Labels.Target.PctHealth.align ),
				anchor = strupper( user_defined.Labels.Target.PctHealth.anchor or nUI_HUDLayout.Labels.Target.PctHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.PctHealth.xOfs or nUI_HUDLayout.Labels.Target.PctHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.PctHealth.yOfs or nUI_HUDLayout.Labels.Target.PctHealth.yOfs ),
				shown  = strlower( user_defined.Labels.Target.PctHealth.shown or nUI_HUDLayout.Labels.Target.PctHealth.shown ),
			},
			MaxPower =
			{
				size   = tonumber( user_defined.Labels.Target.MaxPower.size or nUI_HUDLayout.Labels.Target.MaxPower.size ),
				align  = strupper( user_defined.Labels.Target.MaxPower.align or nUI_HUDLayout.Labels.Target.MaxPower.align ),
				anchor = strupper( user_defined.Labels.Target.MaxPower.anchor or nUI_HUDLayout.Labels.Target.MaxPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.MaxPower.xOfs or nUI_HUDLayout.Labels.Target.MaxPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.MaxPower.yOfs or nUI_HUDLayout.Labels.Target.MaxPower.yOfs ),
				shown  = strlower( user_defined.Labels.Target.MaxPower.shown or nUI_HUDLayout.Labels.Target.MaxPower.shown ),
			},
			CurPower =
			{
				size   = tonumber( user_defined.Labels.Target.CurPower.size or nUI_HUDLayout.Labels.Target.CurPower.size ),
				align  = strupper( user_defined.Labels.Target.CurPower.align or nUI_HUDLayout.Labels.Target.CurPower.align ),
				anchor = strupper( user_defined.Labels.Target.CurPower.anchor or nUI_HUDLayout.Labels.Target.CurPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.CurPower.xOfs or nUI_HUDLayout.Labels.Target.CurPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.CurPower.yOfs or nUI_HUDLayout.Labels.Target.CurPower.yOfs ),
				shown  = strlower( user_defined.Labels.Target.CurPower.shown or nUI_HUDLayout.Labels.Target.CurPower.shown ),
			},
			PctPower =
			{
				size   = tonumber( user_defined.Labels.Target.PctPower.size or nUI_HUDLayout.Labels.Target.PctPower.size ),
				align  = strupper( user_defined.Labels.Target.PctPower.align or nUI_HUDLayout.Labels.Target.PctPower.align ),
				anchor = strupper( user_defined.Labels.Target.PctPower.anchor or nUI_HUDLayout.Labels.Target.PctPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.Target.PctPower.xOfs or nUI_HUDLayout.Labels.Target.PctPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.Target.PctPower.yOfs or nUI_HUDLayout.Labels.Target.PctPower.yOfs ),
				shown  = strlower( user_defined.Labels.Target.PctPower.shown or nUI_HUDLayout.Labels.Target.PctPower.shown ),
			},
		},
		ToT =
		{
			MaxHealth =
			{
				size   = tonumber( user_defined.Labels.ToT.MaxHealth.size or nUI_HUDLayout.Labels.ToT.MaxHealth.size ),
				align  = strupper( user_defined.Labels.ToT.MaxHealth.align or nUI_HUDLayout.Labels.ToT.MaxHealth.align ),
				anchor = strupper( user_defined.Labels.ToT.MaxHealth.anchor or nUI_HUDLayout.Labels.ToT.MaxHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.MaxHealth.xOfs or nUI_HUDLayout.Labels.ToT.MaxHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.MaxHealth.yOfs or nUI_HUDLayout.Labels.ToT.MaxHealth.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.MaxHealth.shown or nUI_HUDLayout.Labels.ToT.MaxHealth.shown ),
			},
			CurHealth =
			{
				size   = tonumber( user_defined.Labels.ToT.CurHealth.size or nUI_HUDLayout.Labels.ToT.CurHealth.size ),
				align  = strupper( user_defined.Labels.ToT.CurHealth.align or nUI_HUDLayout.Labels.ToT.CurHealth.align ),
				anchor = strupper( user_defined.Labels.ToT.CurHealth.anchor or nUI_HUDLayout.Labels.ToT.CurHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.CurHealth.xOfs or nUI_HUDLayout.Labels.ToT.CurHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.CurHealth.yOfs or nUI_HUDLayout.Labels.ToT.CurHealth.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.CurHealth.shown or nUI_HUDLayout.Labels.ToT.CurHealth.shown ),
			},
			PctHealth =
			{
				size   = tonumber( user_defined.Labels.ToT.PctHealth.size or nUI_HUDLayout.Labels.ToT.PctHealth.size ),
				align  = strupper( user_defined.Labels.ToT.PctHealth.align or nUI_HUDLayout.Labels.ToT.PctHealth.align ),
				anchor = strupper( user_defined.Labels.ToT.PctHealth.anchor or nUI_HUDLayout.Labels.ToT.PctHealth.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.PctHealth.xOfs or nUI_HUDLayout.Labels.ToT.PctHealth.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.PctHealth.yOfs or nUI_HUDLayout.Labels.ToT.PctHealth.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.PctHealth.shown or nUI_HUDLayout.Labels.ToT.PctHealth.shown ),
			},
			MaxPower =
			{
				size   = tonumber( user_defined.Labels.ToT.MaxPower.size or nUI_HUDLayout.Labels.ToT.MaxPower.size ),
				align  = strupper( user_defined.Labels.ToT.MaxPower.align or nUI_HUDLayout.Labels.ToT.MaxPower.align ),
				anchor = strupper( user_defined.Labels.ToT.MaxPower.anchor or nUI_HUDLayout.Labels.ToT.MaxPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.MaxPower.xOfs or nUI_HUDLayout.Labels.ToT.MaxPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.MaxPower.yOfs or nUI_HUDLayout.Labels.ToT.MaxPower.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.MaxPower.shown or nUI_HUDLayout.Labels.ToT.MaxPower.shown ),
			},
			CurPower =
			{
				size   = tonumber( user_defined.Labels.ToT.CurPower.size or nUI_HUDLayout.Labels.ToT.CurPower.size ),
				align  = strupper( user_defined.Labels.ToT.CurPower.align or nUI_HUDLayout.Labels.ToT.CurPower.align ),
				anchor = strupper( user_defined.Labels.ToT.CurPower.anchor or nUI_HUDLayout.Labels.ToT.CurPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.CurPower.xOfs or nUI_HUDLayout.Labels.ToT.CurPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.CurPower.yOfs or nUI_HUDLayout.Labels.ToT.CurPower.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.CurPower.shown or nUI_HUDLayout.Labels.ToT.CurPower.shown ),
			},
			PctPower =
			{
				size   = tonumber( user_defined.Labels.ToT.PctPower.size or nUI_HUDLayout.Labels.ToT.PctPower.size ),
				align  = strupper( user_defined.Labels.ToT.PctPower.align or nUI_HUDLayout.Labels.ToT.PctPower.align ),
				anchor = strupper( user_defined.Labels.ToT.PctPower.anchor or nUI_HUDLayout.Labels.ToT.PctPower.anchor ),
				xOfs   = tonumber( user_defined.Labels.ToT.PctPower.xOfs or nUI_HUDLayout.Labels.ToT.PctPower.xOfs ),
				yOfs   = tonumber( user_defined.Labels.ToT.PctPower.yOfs or nUI_HUDLayout.Labels.ToT.PctPower.yOfs ),
				shown  = strlower( user_defined.Labels.ToT.PctPower.shown or nUI_HUDLayout.Labels.ToT.PctPower.shown ),
			},
		},
	};
	self.Origin =
	{
		anchor        = strupper( user_defined.Origin.anchor or nUI_HUDLayout.Origin.anchor ),
		xOfs          = tonumber( user_defined.Origin.xOfs or nUI_HUDLayout.Origin.xOfs ),
		yOfs          = tonumber( user_defined.Origin.yOfs or nUI_HUDLayout.Origin.yOfs ),
	};

	self.Alpha =
	{
		rest      = tonumber( user_defined.Alpha.rest or nUI_HUDLayout.Alpha.rest ),
		regen     = tonumber( user_defined.Alpha.regen or nUI_HUDLayout.Alpha.regen ),
		target    = tonumber( user_defined.Alpha.target or nUI_HUDLayout.Alpha.target ),
		combat    = tonumber( user_defined.Alpha.combat or nUI_HUDLayout.Alpha.combat ),
	};
	
	self.Colors =
	{
		Range =
		{
			melee =
			{
				r =	tonumber( user_defined.Colors.Range.melee.r or nUI_HUDLayout.Colors.Range.melee.r ),
				g =	tonumber( user_defined.Colors.Range.melee.g or nUI_HUDLayout.Colors.Range.melee.g ), 
				b = tonumber( user_defined.Colors.Range.melee.b or nUI_HUDLayout.Colors.Range.melee.b ),
			},
			short =
			{
				r =	tonumber( user_defined.Colors.Range.short.r or nUI_HUDLayout.Colors.Range.short.r ),
				g =	tonumber( user_defined.Colors.Range.short.g or nUI_HUDLayout.Colors.Range.short.g ), 
				b = tonumber( user_defined.Colors.Range.short.b or nUI_HUDLayout.Colors.Range.short.b ),
			},
			med =
			{
				r =	tonumber( user_defined.Colors.Range.med.r or nUI_HUDLayout.Colors.Range.med.r ),
				g =	tonumber( user_defined.Colors.Range.med.g or nUI_HUDLayout.Colors.Range.med.g ), 
				b = tonumber( user_defined.Colors.Range.med.b or nUI_HUDLayout.Colors.Range.med.b ),
			},
			long =
			{
				r =	tonumber( user_defined.Colors.Range.long.r or nUI_HUDLayout.Colors.Range.long.r ),
				g =	tonumber( user_defined.Colors.Range.long.g or nUI_HUDLayout.Colors.Range.long.g ), 
				b = tonumber( user_defined.Colors.Range.long.b or nUI_HUDLayout.Colors.Range.long.b ),
			},
			oor =
			{
				r =	tonumber( user_defined.Colors.Range.oor.r or nUI_HUDLayout.Colors.Range.oor.r ),
				g =	tonumber( user_defined.Colors.Range.oor.g or nUI_HUDLayout.Colors.Range.oor.g ), 
				b = tonumber( user_defined.Colors.Range.oor.b or nUI_HUDLayout.Colors.Range.oor.b ),
			},
		},
		Health =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Health.min.r or nUI_HUDLayout.Colors.Health.min.r ),
				g =	tonumber( user_defined.Colors.Health.min.g or nUI_HUDLayout.Colors.Health.min.g ), 
				b = tonumber( user_defined.Colors.Health.min.b or nUI_HUDLayout.Colors.Health.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Health.mid.r or nUI_HUDLayout.Colors.Health.mid.r ),
				g =	tonumber( user_defined.Colors.Health.mid.g or nUI_HUDLayout.Colors.Health.mid.g ), 
				b = tonumber( user_defined.Colors.Health.mid.b or nUI_HUDLayout.Colors.Health.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Health.mid.r or nUI_HUDLayout.Colors.Health.max.r ),
				g =	tonumber( user_defined.Colors.Health.mid.g or nUI_HUDLayout.Colors.Health.max.g ), 
				b = tonumber( user_defined.Colors.Health.mid.b or nUI_HUDLayout.Colors.Health.max.b ),
			},
		},
		Mana =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Mana.min.r or nUI_HUDLayout.Colors.Mana.min.r ),
				g =	tonumber( user_defined.Colors.Mana.min.g or nUI_HUDLayout.Colors.Mana.min.g ), 
				b = tonumber( user_defined.Colors.Mana.min.b or nUI_HUDLayout.Colors.Mana.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Mana.mid.r or nUI_HUDLayout.Colors.Mana.mid.r ),
				g =	tonumber( user_defined.Colors.Mana.mid.g or nUI_HUDLayout.Colors.Mana.mid.g ), 
				b = tonumber( user_defined.Colors.Mana.mid.b or nUI_HUDLayout.Colors.Mana.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Mana.max.r or nUI_HUDLayout.Colors.Mana.max.r ),
				g =	tonumber( user_defined.Colors.Mana.max.g or nUI_HUDLayout.Colors.Mana.max.g ), 
				b = tonumber( user_defined.Colors.Mana.max.b or nUI_HUDLayout.Colors.Mana.max.b ),
			},
		},
		Rage =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Rage.min.r or nUI_HUDLayout.Colors.Rage.min.r ),
				g =	tonumber( user_defined.Colors.Rage.min.g or nUI_HUDLayout.Colors.Rage.min.g ), 
				b = tonumber( user_defined.Colors.Rage.min.b or nUI_HUDLayout.Colors.Rage.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Rage.mid.r or nUI_HUDLayout.Colors.Rage.mid.r ),
				g =	tonumber( user_defined.Colors.Rage.mid.g or nUI_HUDLayout.Colors.Rage.mid.g ), 
				b = tonumber( user_defined.Colors.Rage.mid.b or nUI_HUDLayout.Colors.Rage.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Rage.max.r or nUI_HUDLayout.Colors.Rage.max.r ),
				g =	tonumber( user_defined.Colors.Rage.max.g or nUI_HUDLayout.Colors.Rage.max.g ), 
				b = tonumber( user_defined.Colors.Rage.max.b or nUI_HUDLayout.Colors.Rage.max.b ),
			},
		},
		Energy =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Energy.min.r or nUI_HUDLayout.Colors.Energy.min.r ),
				g =	tonumber( user_defined.Colors.Energy.min.g or nUI_HUDLayout.Colors.Energy.min.g ), 
				b = tonumber( user_defined.Colors.Energy.min.b or nUI_HUDLayout.Colors.Energy.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Energy.mid.r or nUI_HUDLayout.Colors.Energy.mid.r ),
				g =	tonumber( user_defined.Colors.Energy.mid.g or nUI_HUDLayout.Colors.Energy.mid.g ), 
				b = tonumber( user_defined.Colors.Energy.mid.b or nUI_HUDLayout.Colors.Energy.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Energy.max.r or nUI_HUDLayout.Colors.Energy.max.r ),
				g =	tonumber( user_defined.Colors.Energy.max.g or nUI_HUDLayout.Colors.Energy.max.g ), 
				b = tonumber( user_defined.Colors.Energy.max.b or nUI_HUDLayout.Colors.Energy.max.b ),
			},
		},
		Focus =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Focus.min.r or nUI_HUDLayout.Colors.Focus.min.r ),
				g =	tonumber( user_defined.Colors.Focus.min.g or nUI_HUDLayout.Colors.Focus.min.g ), 
				b = tonumber( user_defined.Colors.Focus.min.b or nUI_HUDLayout.Colors.Focus.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Focus.mid.r or nUI_HUDLayout.Colors.Focus.mid.r ),
				g =	tonumber( user_defined.Colors.Focus.mid.g or nUI_HUDLayout.Colors.Focus.mid.g ), 
				b = tonumber( user_defined.Colors.Focus.mid.b or nUI_HUDLayout.Colors.Focus.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Focus.max.r or nUI_HUDLayout.Colors.Focus.max.r ),
				g =	tonumber( user_defined.Colors.Focus.max.g or nUI_HUDLayout.Colors.Focus.max.g ), 
				b = tonumber( user_defined.Colors.Focus.max.b or nUI_HUDLayout.Colors.Focus.max.b ),
			},
		},
		Latency =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Latency.min.r or nUI_HUDLayout.Colors.Latency.min.r ),
				g =	tonumber( user_defined.Colors.Latency.min.g or nUI_HUDLayout.Colors.Latency.min.g ), 
				b = tonumber( user_defined.Colors.Latency.min.b or nUI_HUDLayout.Colors.Latency.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Latency.mid.r or nUI_HUDLayout.Colors.Latency.mid.r ),
				g =	tonumber( user_defined.Colors.Latency.mid.g or nUI_HUDLayout.Colors.Latency.mid.g ), 
				b = tonumber( user_defined.Colors.Latency.mid.b or nUI_HUDLayout.Colors.Latency.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Latency.max.r or nUI_HUDLayout.Colors.Latency.max.r ),
				g =	tonumber( user_defined.Colors.Latency.max.g or nUI_HUDLayout.Colors.Latency.max.g ), 
				b = tonumber( user_defined.Colors.Latency.max.b or nUI_HUDLayout.Colors.Latency.max.b ),
			},
		},
		Casting =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Casting.min.r or nUI_HUDLayout.Colors.Casting.min.r ),
				g =	tonumber( user_defined.Colors.Casting.min.g or nUI_HUDLayout.Colors.Casting.min.g ), 
				b = tonumber( user_defined.Colors.Casting.min.b or nUI_HUDLayout.Colors.Casting.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Casting.mid.r or nUI_HUDLayout.Colors.Casting.mid.r ),
				g =	tonumber( user_defined.Colors.Casting.mid.g or nUI_HUDLayout.Colors.Casting.mid.g ), 
				b = tonumber( user_defined.Colors.Casting.mid.b or nUI_HUDLayout.Colors.Casting.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Casting.max.r or nUI_HUDLayout.Colors.Casting.max.r ),
				g =	tonumber( user_defined.Colors.Casting.max.g or nUI_HUDLayout.Colors.Casting.max.g ), 
				b = tonumber( user_defined.Colors.Casting.max.b or nUI_HUDLayout.Colors.Casting.max.b ),
			},
		},
		Channeling =
		{
			min =
			{
				r =	tonumber( user_defined.Colors.Channeling.min.r or nUI_HUDLayout.Colors.Channeling.min.r ),
				g =	tonumber( user_defined.Colors.Channeling.min.g or nUI_HUDLayout.Colors.Channeling.min.g ), 
				b = tonumber( user_defined.Colors.Channeling.min.b or nUI_HUDLayout.Colors.Channeling.min.b ),
			},
			mid =
			{
				r =	tonumber( user_defined.Colors.Channeling.mid.r or nUI_HUDLayout.Colors.Channeling.mid.r ),
				g =	tonumber( user_defined.Colors.Channeling.mid.g or nUI_HUDLayout.Colors.Channeling.mid.g ), 
				b = tonumber( user_defined.Colors.Channeling.mid.b or nUI_HUDLayout.Colors.Channeling.mid.b ),
			},
			max =
			{
				r =	tonumber( user_defined.Colors.Channeling.max.r or nUI_HUDLayout.Colors.Channeling.max.r ),
				g =	tonumber( user_defined.Colors.Channeling.max.g or nUI_HUDLayout.Colors.Channeling.max.g ), 
				b = tonumber( user_defined.Colors.Channeling.max.b or nUI_HUDLayout.Colors.Channeling.max.b ),
			},
		},
	};
		
	self.BarLayouts = {};
	
	local layout;
	
	layout =
	{
		name    = "nUI_HUD_PlayerCasting";
		width   = self.Bars.Player.Casting.width;
		height  = self.Bars.Player.Casting.height;		
		Colors  = self.Bars.Player.Colors.Casting;
		Options = self.Bars.Player.Options;
	};
	
	self.BarLayouts.PlayerCasting = nUI.Class.UnitBar_CastingLayout:new( layout );

	layout =
	{
		name    = "nUI_HUD_PlayerChannel";
		width   = self.Bars.Player.Casting.width;
		height  = self.Bars.Player.Casting.height;		
		Colors  = self.Bars.Player.Colors.Channeling;
		Options = self.Bars.Player.Options;
	};
	
	self.BarLayouts.PlayerChanneling = nUI.Class.UnitBar_ChannelingLayout:new( layout );

	layout =
	{
		name    = "nUI_HUD_PlayerLatency";
		width   = self.Bars.Player.Casting.width;
		height  = self.Bars.Player.Latency.height;		
		Colors  = self.Bars.Player.Colors.Latency;
		Options = 
		{
			show_name = "none",
			cur_value = "none",
			max_value = "none",
			min_value = "none",
			percent   = "none",
			grow      = self.BarLayouts.PlayerCasting.Options.grow,
		};
	};
	
	self.BarLayouts.PlayerLatency = nUI.Class.UnitBar_LatencyLayout:new( layout );

	layout =
	{
		name    = "nUI_HUD_PetCasting";
		width   = self.Bars.Player.Casting.width;
		height  = self.Bars.Player.Casting.height / 2;		
		Colors  = self.Bars.Player.Colors.Casting;
	};
	
	self.BarLayouts.PetCasting = nUI.Class.UnitBar_CastingLayout:new( layout );

	layout =
	{
		name    = "nUI_HUD_PetChannel";
		width   = self.Bars.Player.Casting.width;
		height  = self.Bars.Player.Casting.height * 7 / 12;		
		Colors  = self.Bars.Player.Colors.Channeling;
		Options =
		{
			show_name = "min",
			cur_value = "none",
			max_value = "none",
			min_value = "none",
			percent   = "max",
		},
	};
	
	self.BarLayouts.PetChanneling = nUI.Class.UnitBar_ChannelingLayout:new( layout );
	
	layout =
	{
		name    = "nUI_HUD_TargetCasting";
		width   = self.Bars.Target.Casting.width;
		height  = self.Bars.Target.Casting.height;		
		Colors  = self.Bars.Target.Colors.Casting;
		Options = self.Bars.Target.Options;
	};
	
	self.BarLayouts.TargetCasting = nUI.Class.UnitBar_CastingLayout:new( layout );

	layout =
	{
		name    = "nUI_HUD_TargetChannel";
		width   = self.Bars.Target.Casting.width;
		height  = self.Bars.Target.Casting.height;		
		Colors  = self.Bars.Target.Colors.Channeling;
		Options = self.Bars.Target.Options;
	};
	
	self.BarLayouts.TargetChanneling = nUI.Class.UnitBar_ChannelingLayout:new( layout );
	
	self.Buffs =
	{
		Casts =
		{
			visible    = strlower( user_defined.Buffs.Casts.visible or nUI_HUDLayout.Buffs.Casts.visible ),
			highlight  = strlower( user_defined.Buffs.Casts.highlight or nUI_HUDLayout.Buffs.Casts.highlight ),
			timers     = strlower( user_defined.Buffs.Casts.timers or nUI_HUDLayout.Buffs.Casts.timers ),
			anim       = strlower( user_defined.Buffs.Casts.anim or nUI_HUDLayout.Buffs.Casts.anim ),
			flash      = tonumber( user_defined.Buffs.Casts.flash or nUI_HUDLayout.Buffs.Casts.flash ),
			flash_rate = tonumber( user_defined.Buffs.Casts.flash_rate or nUI_HUDLayout.Buffs.Casts.flash_rate ),
			
			Shape =
			{
				orient = strupper( user_defined.Buffs.Casts.Shape.orient or nUI_HUDLayout.Buffs.Casts.Shape.orient ),
				grow   = strlower( user_defined.Buffs.Casts.Shape.grow or nUI_HUDLayout.Buffs.Casts.Shape.grow ),
				rows   = tonumber( user_defined.Buffs.Casts.Shape.rows or nUI_HUDLayout.Buffs.Casts.Shape.rows ),
				size   = tonumber( user_defined.Buffs.Casts.Shape.size or nUI_HUDLayout.Buffs.Casts.Shape.size ),
				gap    = tonumber( user_defined.Buffs.Casts.Shape.gap or nUI_HUDLayout.Buffs.Casts.Shape.gap ),
			},
			
			Origin =
			{
				anchor = strupper( user_defined.Buffs.Casts.Origin.anchor or nUI_HUDLayout.Buffs.Casts.Origin.anchor ),
				xOfs   = tonumber( user_defined.Buffs.Casts.Origin.xOfs or nUI_HUDLayout.Buffs.Casts.Origin.xOfs ),
				yOfs   = tonumber( user_defined.Buffs.Casts.Origin.yOfs or nUI_HUDLayout.Buffs.Casts.Origin.yOfs ),
			},
		},
		Player =
		{
			visible    = strlower( user_defined.Buffs.Player.visible or nUI_HUDLayout.Buffs.Player.visible ),
			highlight  = strlower( user_defined.Buffs.Player.highlight or nUI_HUDLayout.Buffs.Player.highlight ),
			timers     = strlower( user_defined.Buffs.Player.timers or nUI_HUDLayout.Buffs.Player.timers ),
			anim       = strlower( user_defined.Buffs.Player.anim or nUI_HUDLayout.Buffs.Player.anim ),
			flash      = tonumber( user_defined.Buffs.Player.flash or nUI_HUDLayout.Buffs.Player.flash ),
			flash_rate = tonumber( user_defined.Buffs.Player.flash_rate or nUI_HUDLayout.Buffs.Player.flash_rate ),
			
			Shape =
			{
				orient = strupper( user_defined.Buffs.Player.Shape.orient or nUI_HUDLayout.Buffs.Player.Shape.orient ),
				grow   = strlower( user_defined.Buffs.Player.Shape.grow or nUI_HUDLayout.Buffs.Player.Shape.grow ),
				rows   = tonumber( user_defined.Buffs.Player.Shape.rows or nUI_HUDLayout.Buffs.Player.Shape.rows ),
				size   = tonumber( user_defined.Buffs.Player.Shape.size or nUI_HUDLayout.Buffs.Player.Shape.size ),
				gap    = tonumber( user_defined.Buffs.Player.Shape.gap or nUI_HUDLayout.Buffs.Player.Shape.gap ),
			},
			
			Origin =
			{
				anchor = strupper( user_defined.Buffs.Player.Origin.anchor or nUI_HUDLayout.Buffs.Player.Origin.anchor ),
				xOfs   = tonumber( user_defined.Buffs.Player.Origin.xOfs or nUI_HUDLayout.Buffs.Player.Origin.xOfs ),
				yOfs   = tonumber( user_defined.Buffs.Player.Origin.yOfs or nUI_HUDLayout.Buffs.Player.Origin.yOfs ),
			},
		},
		Pet =
		{
			visible    = strlower( user_defined.Buffs.Pet.visible or nUI_HUDLayout.Buffs.Pet.visible ),
			highlight  = strlower( user_defined.Buffs.Pet.highlight or nUI_HUDLayout.Buffs.Pet.highlight ),
			timers     = strlower( user_defined.Buffs.Pet.timers or nUI_HUDLayout.Buffs.Pet.timers ),
			anim       = strlower( user_defined.Buffs.Pet.anim or nUI_HUDLayout.Buffs.Pet.anim ),
			flash      = tonumber( user_defined.Buffs.Pet.flash or nUI_HUDLayout.Buffs.Pet.flash ),
			flash_rate = tonumber( user_defined.Buffs.Pet.flash_rate or nUI_HUDLayout.Buffs.Pet.flash_rate ),
			
			Shape =
			{
				orient = strupper( user_defined.Buffs.Pet.Shape.orient or nUI_HUDLayout.Buffs.Pet.Shape.orient ),
				grow   = strlower( user_defined.Buffs.Pet.Shape.grow or nUI_HUDLayout.Buffs.Pet.Shape.grow ),
				rows   = tonumber( user_defined.Buffs.Pet.Shape.rows or nUI_HUDLayout.Buffs.Pet.Shape.rows ),
				size   = tonumber( user_defined.Buffs.Pet.Shape.size or nUI_HUDLayout.Buffs.Pet.Shape.size ),
				gap    = tonumber( user_defined.Buffs.Pet.Shape.gap or nUI_HUDLayout.Buffs.Pet.Shape.gap ),
			},
			
			Origin =
			{
				anchor = strupper( user_defined.Buffs.Pet.Origin.anchor or nUI_HUDLayout.Buffs.Pet.Origin.anchor ),
				xOfs   = tonumber( user_defined.Buffs.Pet.Origin.xOfs or nUI_HUDLayout.Buffs.Pet.Origin.xOfs ),
				yOfs   = tonumber( user_defined.Buffs.Pet.Origin.yOfs or nUI_HUDLayout.Buffs.Pet.Origin.yOfs ),
			},
		},
		Target =
		{
			visible    = strlower( user_defined.Buffs.Target.visible or nUI_HUDLayout.Buffs.Target.visible ),
			highlight  = strlower( user_defined.Buffs.Target.highlight or nUI_HUDLayout.Buffs.Target.highlight ),
			timers     = strlower( user_defined.Buffs.Target.timers or nUI_HUDLayout.Buffs.Target.timers ),
			anim       = strlower( user_defined.Buffs.Target.anim or nUI_HUDLayout.Buffs.Target.anim ),
			flash      = tonumber( user_defined.Buffs.Target.flash or nUI_HUDLayout.Buffs.Target.flash ),
			flash_rate = tonumber( user_defined.Buffs.Target.flash_rate or nUI_HUDLayout.Buffs.Target.flash_rate ),
			
			Shape =
			{
				orient = strupper( user_defined.Buffs.Target.Shape.orient or nUI_HUDLayout.Buffs.Target.Shape.orient ),
				grow   = strlower( user_defined.Buffs.Target.Shape.grow or nUI_HUDLayout.Buffs.Target.Shape.grow ),
				rows   = tonumber( user_defined.Buffs.Target.Shape.rows or nUI_HUDLayout.Buffs.Target.Shape.rows ),
				size   = tonumber( user_defined.Buffs.Target.Shape.size or nUI_HUDLayout.Buffs.Target.Shape.size ),
				gap    = tonumber( user_defined.Buffs.Target.Shape.gap or nUI_HUDLayout.Buffs.Target.Shape.gap ),
			},
			
			Origin =
			{
				anchor = strupper( user_defined.Buffs.Target.Origin.anchor or nUI_HUDLayout.Buffs.Target.Origin.anchor ),
				xOfs   = tonumber( user_defined.Buffs.Target.Origin.xOfs or nUI_HUDLayout.Buffs.Target.Origin.xOfs ),
				yOfs   = tonumber( user_defined.Buffs.Target.Origin.yOfs or nUI_HUDLayout.Buffs.Target.Origin.yOfs ),
			},
		},
		ToT =
		{
			visible    = strlower( user_defined.Buffs.ToT.visible or nUI_HUDLayout.Buffs.ToT.visible ),
			highlight  = strlower( user_defined.Buffs.ToT.highlight or nUI_HUDLayout.Buffs.ToT.highlight ),
			timers     = strlower( user_defined.Buffs.ToT.timers or nUI_HUDLayout.Buffs.ToT.timers ),
			anim       = strlower( user_defined.Buffs.ToT.anim or nUI_HUDLayout.Buffs.ToT.anim ),
			flash      = tonumber( user_defined.Buffs.ToT.flash or nUI_HUDLayout.Buffs.ToT.flash ),
			flash_rate = tonumber( user_defined.Buffs.ToT.flash_rate or nUI_HUDLayout.Buffs.ToT.flash_rate ),
			
			Shape =
			{
				orient = strupper( user_defined.Buffs.ToT.Shape.orient or nUI_HUDLayout.Buffs.ToT.Shape.orient ),
				grow   = strlower( user_defined.Buffs.ToT.Shape.grow or nUI_HUDLayout.Buffs.ToT.Shape.grow ),
				rows   = tonumber( user_defined.Buffs.ToT.Shape.rows or nUI_HUDLayout.Buffs.ToT.Shape.rows ),
				size   = tonumber( user_defined.Buffs.ToT.Shape.size or nUI_HUDLayout.Buffs.ToT.Shape.size ),
				gap    = tonumber( user_defined.Buffs.ToT.Shape.gap or nUI_HUDLayout.Buffs.ToT.Shape.gap ),
			},
			
			Origin =
			{
				anchor = strupper( user_defined.Buffs.ToT.Origin.anchor or nUI_HUDLayout.Buffs.ToT.Origin.anchor ),
				xOfs   = tonumber( user_defined.Buffs.ToT.Origin.xOfs or nUI_HUDLayout.Buffs.ToT.Origin.xOfs ),
				yOfs   = tonumber( user_defined.Buffs.ToT.Origin.yOfs or nUI_HUDLayout.Buffs.ToT.Origin.yOfs ),
			},
		},
	};
end